Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.jmx.support
Class ConnectorServerFactoryBean

    java.lang.Object
      org.springframework.jmx.support.MBeanRegistrationSupport
          org.springframework.jmx.support.ConnectorServerFactoryBean

All Implemented Interfaces:
  DisposableBean, FactoryBean<javax.management.remote.JMXConnectorServer>, InitializingBean

    public class ConnectorServerFactoryBean

extends MBeanRegistrationSupport
implements FactoryBean<javax.management.remote.JMXConnectorServer>, InitializingBean, DisposableBean

`FactoryBean` that creates a JSR-160 `JMXConnectorServer`, optionally registers it with the `MBeanServer` and then starts it.

The `JMXConnectorServer` can be started in a separate thread by setting the `threaded` property to `true`. You can configure this thread to be a daemon thread by setting the `daemon` property to `true`.

The `JMXConnectorServer` is correctly shutdown when an instance of this class is destroyed on shutdown of the containing `ApplicationContext`.

Since:
  1.2
Author:
  Rob Harrop, Juergen Hoeller
See Also:
  `FactoryBean`, `JMXConnectorServer`, `MBeanServer`

Field Summary
`static java.lang.String` | `DEFAULT_SERVICE_URL` The default service URL

Fields inherited from class org.springframework.jmx.support.MBeanRegistrationSupport
`logger, registeredBeans, REGISTRATION_FAIL_ON_EXISTING, REGISTRATION_IGNORE_EXISTING, REGISTRATION_REPLACE_EXISTING, server`

Constructor Summary
`ConnectorServerFactoryBean()`

Method Summary
`void` | `afterPropertiesSet()` Start the connector server.
`void` | `destroy()` Stop the `JMXConnectorServer` managed by an instance of this class.
`javax.management.remote.JMXConnectorServer` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
`java.lang.Class<? extends javax.management.remote.JMXConnectorServer>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
`boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
`void` | `setDaemon(boolean daemon)` Set whether any threads started for the `JMXConnectorServer` should be started as daemon threads.
`void` | `setEnvironment(java.util.Properties environment)` Set the environment properties used to construct the `JMXConnectorServer` as `java.util.Properties` (String key/value pairs).
`void` | `setEnvironmentMap(java.util.Map<java.lang.String,?> environment)` Set the environment properties used to construct the `JMXConnector` as a `Map` of String keys and arbitrary Object values.
`void` | `setForwarder(javax.management.remote.MBeanServerForwarder forwarder)` Set an MBeanServerForwarder to be applied to the `JMXConnectorServer`.
`void` | `setObjectName(java.lang.Object objectName)` Set the `ObjectName` used to register the `JMXConnectorServer` itself with the `MBeanServer`, as `ObjectName` instance or as `String`.
`void` | `setServiceUrl(java.lang.String serviceUrl)` Set the service URL for the `JMXConnectorServer`.
`void` | `setThreaded(boolean threaded)` Set whether the `JMXConnectorServer` should be started in a separate thread.

Methods inherited from class org.springframework.jmx.support.MBeanRegistrationSupport
`doRegister, doUnregister, getRegisteredObjectNames, getServer, onRegister, onRegister, onUnregister, setRegistrationBehavior, setRegistrationBehaviorName, setServer, unregisterBeans`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_SERVICE_URL

    public static final java.lang.String DEFAULT_SERVICE_URL

  The default service URL

  See Also:
    Constant Field Values

Constructor Detail

### ConnectorServerFactoryBean

    public ConnectorServerFactoryBean()

Method Detail

### setServiceUrl

    public void setServiceUrl(java.lang.String serviceUrl)

  Set the service URL for the `JMXConnectorServer`.

### setEnvironment

    public void setEnvironment(java.util.Properties environment)

  Set the environment properties used to construct the `JMXConnectorServer` as `java.util.Properties` (String key/value pairs).

### setEnvironmentMap

    public void setEnvironmentMap(java.util.Map<java.lang.String,?> environment)

  Set the environment properties used to construct the `JMXConnector` as a `Map` of String keys and arbitrary Object values.

### setForwarder

    public void setForwarder(javax.management.remote.MBeanServerForwarder forwarder)

  Set an MBeanServerForwarder to be applied to the `JMXConnectorServer`.

### setObjectName

    public void setObjectName(java.lang.Object objectName)
                       throws javax.management.MalformedObjectNameException

  Set the `ObjectName` used to register the `JMXConnectorServer` itself with the `MBeanServer`, as `ObjectName` instance or as `String`.

  Throws:
    `javax.management.MalformedObjectNameException` - if the `ObjectName` is malformed

### setThreaded

    public void setThreaded(boolean threaded)

  Set whether the `JMXConnectorServer` should be started in a separate thread.

### setDaemon

    public void setDaemon(boolean daemon)

  Set whether any threads started for the `JMXConnectorServer` should be started as daemon threads.

### afterPropertiesSet

    public void afterPropertiesSet()
                            throws javax.management.JMException,
                                   java.io.IOException

  Start the connector server. If the `threaded` flag is set to `true`, the `JMXConnectorServer` will be started in a separate thread. If the `daemon` flag is set to `true`, that thread will be started as a daemon thread.

  Specified by:
    `afterPropertiesSet` in interface `InitializingBean`
  Throws:
    `javax.management.JMException` - if a problem occured when registering the connector server with the `MBeanServer`
    `java.io.IOException` - if there is a problem starting the connector server

### getObject

    public javax.management.remote.JMXConnectorServer getObject()

  Description copied from interface: `FactoryBean`
  Return an instance (possibly shared or independent) of the object managed by this factory.

  As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

  If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

  As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

  Specified by:
    `getObject` in interface `FactoryBean<javax.management.remote.JMXConnectorServer>`
  Returns:
    an instance of the bean (can be `null`)
  See Also:
    `FactoryBeanNotInitializedException`

### getObjectType

    public java.lang.Class<? extends javax.management.remote.JMXConnectorServer> getObjectType()

  Description copied from interface: `FactoryBean`
  Return the type of object that this FactoryBean creates, or `null` if not known in advance.

  This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

  In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

  This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

  NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

  Specified by:
    `getObjectType` in interface `FactoryBean<javax.management.remote.JMXConnectorServer>`
  Returns:
    the type of object that this FactoryBean creates, or `null` if not known at the time of the call
  See Also:
    `ListableBeanFactory.getBeansOfType(java.lang.Class)`

### isSingleton

    public boolean isSingleton()

  Description copied from interface: `FactoryBean`
  Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

  NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

  The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

  NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

  Specified by:
    `isSingleton` in interface `FactoryBean<javax.management.remote.JMXConnectorServer>`
  Returns:
    whether the exposed object is a singleton
  See Also:
    `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`

### destroy

    public void destroy()
                 throws java.io.IOException

  Stop the `JMXConnectorServer` managed by an instance of this class. Automatically called on `ApplicationContext` shutdown.

  Specified by:
    `destroy` in interface `DisposableBean`
  Throws:
    `java.io.IOException` - if there is an error stopping the connector server

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD